package org.netkernel.layer0.module.java;
/******************************************************************************
(c) Copyright 2002-2006, 1060 Research Ltd                                   

This Software is licensed to You, the licensee, for use under the terms of   
the 1060 Public License v1.0. Please read and agree to the 1060 Public       
License v1.0 [www.1060research.com/license] before using or redistributing   
this software.                                                               

In summary the 1060 Public license has the following conditions.             
A. You may use the Software free of charge provided you agree to the terms   
laid out in the 1060 Public License v1.0                                     
B. You are only permitted to use the Software with components or applications
that provide you with OSI Certified Open Source Code [www.opensource.org], or
for which licensing has been approved by 1060 Research Limited.              
You may write your own software for execution by this Software provided any  
distribution of your software with this Software complies with terms set out 
in section 2 of the 1060 Public License v1.0                                 
C. You may redistribute the Software provided you comply with the terms of   
the 1060 Public License v1.0 and that no warranty is implied or given.       
D. If you find you are unable to comply with this license you may seek to    
obtain an alternative license from 1060 Research Limited by contacting       
license@1060research.com or by visiting www.1060research.com                 

NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
LICENSE V1.0 FOR DETAILS                                                     

THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      

File:          $RCSfile$
Version:       $Name$ $Revision$
Last Modified: $Date$
*****************************************************************************/

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.net.*;

import org.netkernel.container.IKernel;
import org.netkernel.container.ILogger;
import org.netkernel.layer0.boot.IModule;
import org.netkernel.layer0.boot.IModuleFactory;

/** Looks for a raw module with a class Module in the default package and a URI argument constructor
 * @author Tony Butterfield
 */
public class JavaModuleFactory implements IModuleFactory
{
	private static String MODULE_CLASS="Module";
	private static Class[] CONSTRUCTOR_ARGS = new Class[] {URI.class,IKernel.class};
	
	public IModule buildModule(URI aModuleURI, IKernel aKernel) throws Exception
	{
		URL u =aModuleURI.toURL();
		URLClassLoader cl=new URLClassLoader(new URL[] {u},JavaModuleFactory.class.getClassLoader());
		Class c;
		Constructor ctr=null;
		try
		{	c=cl.loadClass(MODULE_CLASS);
			ctr=c.getConstructor(CONSTRUCTOR_ARGS);
			IModule result = (IModule)ctr.newInstance(new Object[] {aModuleURI,aKernel} );
			return result;
		}
		catch (ClassNotFoundException e)
		{	return null;
		}
		catch (NoSuchMethodException e)
		{	return null;
		}
		catch(InvocationTargetException e)
		{	aKernel.getLogger().logRaw(ILogger.WARNING, this, e.getCause().toString());
			return null;
		}
	}

}